﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices
Public Class c1_Person
    Implements INotifyPropertyChanged

    Public Sub New()
        If DesignerProperties.GetIsInDesignMode(New DependencyObject) Then
            VorName = "bsp vname"
            NachName = "bsp gname"
            RefNr = "123"
        Else
        End If
    End Sub
    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private _RefNr As String = ""
    Public Property RefNr As String
        Get
            Return _RefNr
        End Get
        Set(ByVal value As String)
            _RefNr = value
            RaisePropertyChanged()
        End Set
    End Property
    Private _VorName As String = ""
    Public Property VorName As String
        Get
            Return _VorName
        End Get
        Set(ByVal value As String)
            _VorName = value
            RaisePropertyChanged()
        End Set
    End Property
    Private _GeburtsName As String = ""
    Public Property NachName As String
        Get
            Return _GeburtsName
        End Get
        Set(ByVal value As String)
            _GeburtsName = value
            RaisePropertyChanged()
        End Set
    End Property
    Public Overrides Function ToString() As String
        Return RefNr & " " & VorName & " " & NachName
    End Function
    '------------------------------------------------------------------------------------------------------
    'click
    Private _clickPerson As ICommand
    Public Event eventClickPerson(ByRef p As c1_Person)
    Public ReadOnly Property ClickPerson As ICommand
        Get
            If _clickPerson Is Nothing Then _
                _clickPerson = New RelayCommand(AddressOf DieMethodeFuerExecute, AddressOf DieMethodeFuerCanExecute)
            Return _clickPerson
        End Get
    End Property
    Private Sub DieMethodeFuerExecute(obj As Object)
        'MessageBox.Show(VorName)
        RaiseEvent eventClickPerson(Me)
    End Sub
    Private Function DieMethodeFuerCanExecute(obj As Object) As Boolean
        'Prüfen ob man klicken darf - Button wir dann Disabled oder Enabled
        Return True 'Hier das Ergebniss zurückgeben
    End Function


End Class





